Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp	(revision 34562)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp	(revision 34563)
@@ -1929,5 +1929,5 @@
                 else
                 {
-                    errorArgument("Invalid --vrdpauthtype argument '%s'", ValueUnion.psz);
+                    errorArgument("Invalid --vrdeauthtype argument '%s'", ValueUnion.psz);
                     rc = E_FAIL;
                 }
Index: trunk/src/VBox/HostDrivers/Support/SUPR3HardenedVerify.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/SUPR3HardenedVerify.cpp	(revision 34562)
+++ trunk/src/VBox/HostDrivers/Support/SUPR3HardenedVerify.cpp	(revision 34563)
@@ -159,4 +159,5 @@
 
     {   kSupIFT_Dll,  kSupID_SharedLib,          true, "VRDPAuth" SUPLIB_DLL_SUFF },
+    {   kSupIFT_Dll,  kSupID_SharedLib,          true, "VBoxAuth" SUPLIB_DLL_SUFF },
     {   kSupIFT_Dll,  kSupID_SharedLib,          true, "VBoxVRDP" SUPLIB_DLL_SUFF },
 
Index: trunk/src/VBox/HostServices/auth/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostServices/auth/Makefile.kmk	(revision 34562)
+++ trunk/src/VBox/HostServices/auth/Makefile.kmk	(revision 34563)
@@ -54,5 +54,5 @@
 VBoxAuth-sdkhdr_INST = $(INST_SDK)/bindings/auth/include/
 VBoxAuth-sdkhdr_MODE = a+r,u+w
-VBoxAuth-sdkhdr_SOURCES = $(PATH_ROOT)/include/VBox/VRDPAuth.h=>VRDPAuth.h
+VBoxAuth-sdkhdr_SOURCES = $(PATH_ROOT)/include/VBox/VBoxAuth.h=>VBoxAuth.h
 
 
Index: trunk/src/VBox/HostServices/auth/directoryservice/directoryservice.cpp
===================================================================
--- trunk/src/VBox/HostServices/auth/directoryservice/directoryservice.cpp	(revision 34562)
+++ trunk/src/VBox/HostServices/auth/directoryservice/directoryservice.cpp	(revision 34563)
@@ -22,5 +22,5 @@
 #include <iprt/assert.h>
 
-#include <VBox/VRDPAuth.h>
+#include <VBox/VBoxAuth.h>
 
 #include <DirectoryService/DirectoryService.h>
Index: trunk/src/VBox/HostServices/auth/pam/VBoxAuthPAM.c
===================================================================
--- trunk/src/VBox/HostServices/auth/pam/VBoxAuthPAM.c	(revision 34562)
+++ trunk/src/VBox/HostServices/auth/pam/VBoxAuthPAM.c	(revision 34563)
@@ -28,5 +28,5 @@
  * service must be lowercase. See PAM documentation for details.
  *
- * The VRDPAuth module takes the PAM service name from the
+ * The Auth module takes the PAM service name from the
  * environment variable VRDP_AUTH_PAM_SERVICE. If the variable
  * is not specified, then the 'login' PAM service is used.
@@ -77,5 +77,5 @@
 #include <security/pam_appl.h>
 
-#include <VBox/VRDPAuth.h>
+#include <VBox/VBoxAuth.h>
 
 #ifdef VRDP_PAM_DLLOAD
Index: trunk/src/VBox/HostServices/auth/simple/VBoxAuthSimple.cpp
===================================================================
--- trunk/src/VBox/HostServices/auth/simple/VBoxAuthSimple.cpp	(revision 34562)
+++ trunk/src/VBox/HostServices/auth/simple/VBoxAuthSimple.cpp	(revision 34563)
@@ -26,5 +26,5 @@
 #include <iprt/sha.h>
 
-#include <VBox/VRDPAuth.h>
+#include <VBox/VBoxAuth.h>
 
 #include <VBox/com/com.h>
@@ -36,10 +36,10 @@
 
 /* If defined, debug messages will be written to the specified file. */
-//#define VRDPAUTH_DEBUG_FILE_NAME "/tmp/VRDPAuth.log"
+//#define AUTH_DEBUG_FILE_NAME "/tmp/VBoxAuth.log"
 
 
 static void dprintf(const char *fmt, ...)
 {
-#ifdef VRDPAUTH_DEBUG_FILE_NAME
+#ifdef AUTH_DEBUG_FILE_NAME
     va_list va;
 
@@ -50,5 +50,5 @@
     vsnprintf(buffer, sizeof(buffer), fmt, va);
 
-    FILE *f = fopen(VRDPAUTH_DEBUG_FILE_NAME, "ab");
+    FILE *f = fopen(AUTH_DEBUG_FILE_NAME, "ab");
     if (f)
     {
Index: trunk/src/VBox/HostServices/auth/winlogon/winlogon.cpp
===================================================================
--- trunk/src/VBox/HostServices/auth/winlogon/winlogon.cpp	(revision 34562)
+++ trunk/src/VBox/HostServices/auth/winlogon/winlogon.cpp	(revision 34563)
@@ -26,5 +26,5 @@
 #include <Windows.h>
 
-#include <VBox/VRDPAuth.h>
+#include <VBox/VBoxAuth.h>
 
 static void dprintf(const char *fmt, ...)
Index: trunk/src/VBox/Installer/freebsd/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/freebsd/Makefile.kmk	(revision 34562)
+++ trunk/src/VBox/Installer/freebsd/Makefile.kmk	(revision 34563)
@@ -182,5 +182,5 @@
  VBOX_FBSD_STRIP_BIN += \
 	VBoxVRDP.so \
-	VRDPAuth.so
+	VBoxAuth.so
  VBOX_FBSD_NO_STRIP += \
 	rdesktop-vrdp.tar.gz
Index: trunk/src/VBox/Installer/linux/debian/lintian-override.in
===================================================================
--- trunk/src/VBox/Installer/linux/debian/lintian-override.in	(revision 34562)
+++ trunk/src/VBox/Installer/linux/debian/lintian-override.in	(revision 34563)
@@ -15,5 +15,5 @@
 %VERPKG%: shlib-with-non-pic-code usr/lib/virtualbox/VBoxNetDHCP.so
 %VERPKG%: shlib-with-non-pic-code usr/lib/virtualbox/VBoxVRDP.so
-%VERPKG%: shlib-with-non-pic-code usr/lib/virtualbox/VRDPAuth.so
+%VERPKG%: shlib-with-non-pic-code usr/lib/virtualbox/VBoxAuth.so
 %VERPKG%: shlib-with-non-pic-code usr/lib/virtualbox/components/VBoxSVCM.so
 %VERPKG%: shlib-with-non-pic-code usr/lib/virtualbox/components/VBoxC.so
@@ -49,5 +49,5 @@
 %VERPKG%: no-shlibs-control-file usr/lib/virtualbox/VBoxGuestControlSvc.so
 %VERPKG%: no-shlibs-control-file usr/lib/virtualbox/VBoxVRDP.so
-%VERPKG%: no-shlibs-control-file usr/lib/virtualbox/VRDPAuth.so
+%VERPKG%: no-shlibs-control-file usr/lib/virtualbox/VBoxAuth.so
 %VERPKG%: binary-or-shlib-defines-rpath ./usr/bin/rdesktop-vrdp /usr/lib/virtualbox
 %VERPKG%: binary-or-shlib-defines-rpath ./usr/lib/virtualbox/VBoxDD.so /usr/lib/virtualbox
@@ -81,5 +81,5 @@
 %VERPKG%: binary-or-shlib-defines-rpath ./usr/lib/virtualbox/VBoxXPCOM.so /usr/lib/virtualbox
 %VERPKG%: binary-or-shlib-defines-rpath ./usr/lib/virtualbox/VBoxXPCOMIPCD /usr/lib/virtualbox
-%VERPKG%: binary-or-shlib-defines-rpath ./usr/lib/virtualbox/VRDPAuth.so /usr/lib/virtualbox
+%VERPKG%: binary-or-shlib-defines-rpath ./usr/lib/virtualbox/VBoxAuth.so /usr/lib/virtualbox
 %VERPKG%: binary-or-shlib-defines-rpath ./usr/lib/virtualbox/VirtualBox /usr/lib/virtualbox
 %VERPKG%: binary-or-shlib-defines-rpath ./usr/lib/virtualbox/VirtualBox.so /usr/lib/virtualbox
Index: trunk/src/VBox/Installer/linux/deffiles
===================================================================
--- trunk/src/VBox/Installer/linux/deffiles	(revision 34562)
+++ trunk/src/VBox/Installer/linux/deffiles	(revision 34563)
@@ -475,5 +475,5 @@
     sdk/include/ipcITransactionObserver.h \
     sdk/include/VirtualBox_XPCOM.h \
-    sdk/include/VRDPAuth.h \
+    sdk/include/VBoxAuth.h \
     sdk/installer/build/lib/vboxapi/VirtualBox_constants.py
     sdk/installer/build/lib/vboxapi/__init__.py
@@ -573,6 +573,6 @@
     sdk/webservice/vboxwebService.wsdl \
     sdk/samples/ \
-    sdk/samples/vrdpauth/ \
-    sdk/samples/vrdpauth/pam.cpp \
+    sdk/samples/auth/ \
+    sdk/samples/auth/pam.cpp \
     sdk/samples/API/ \
     sdk/samples/API/tstVBoxAPILinux.cpp \
Index: trunk/src/VBox/Installer/linux/install.sh
===================================================================
--- trunk/src/VBox/Installer/linux/install.sh	(revision 34562)
+++ trunk/src/VBox/Installer/linux/install.sh	(revision 34563)
@@ -334,5 +334,5 @@
     if [ -x /usr/bin/chcon ]; then
         chcon -t texrel_shlib_t $INSTALLATION_DIR/VBox* > /dev/null 2>&1
-        chcon -t texrel_shlib_t $INSTALLATION_DIR/VRDPAuth.so > /dev/null 2>&1
+        chcon -t texrel_shlib_t $INSTALLATION_DIR/VBoxAuth.so > /dev/null 2>&1
         chcon -t texrel_shlib_t $INSTALLATION_DIR/VirtualBox.so > /dev/null 2>&1
         chcon -t texrel_shlib_t $INSTALLATION_DIR/components/VBox*.so > /dev/null 2>&1
Index: trunk/src/VBox/Installer/linux/rpm/VirtualBox.tmpl.spec
===================================================================
--- trunk/src/VBox/Installer/linux/rpm/VirtualBox.tmpl.spec	(revision 34562)
+++ trunk/src/VBox/Installer/linux/rpm/VirtualBox.tmpl.spec	(revision 34563)
@@ -248,5 +248,5 @@
   chcon -t texrel_shlib_t /usr/lib/virtualbox/*VBox* > /dev/null 2>&1
   chcon -t texrel_shlib_t /usr/lib/virtualbox/VirtualBox.so > /dev/null 2>&1
-  chcon -t texrel_shlib_t /usr/lib/virtualbox/VRDPAuth.so > /dev/null 2>&1
+  chcon -t texrel_shlib_t /usr/lib/virtualbox/VBoxAuth.so > /dev/null 2>&1
   chcon -t texrel_shlib_t /usr/lib/virtualbox/components/VBox*.so > /dev/null 2>&1
   chcon -t java_exec_t    /usr/lib/virtualbox/VirtualBox > /dev/null 2>&1
Index: trunk/src/VBox/Main/SystemPropertiesImpl.cpp
===================================================================
--- trunk/src/VBox/Main/SystemPropertiesImpl.cpp	(revision 34562)
+++ trunk/src/VBox/Main/SystemPropertiesImpl.cpp	(revision 34563)
@@ -1064,5 +1064,5 @@
         m->strVRDEAuthLibrary = aPath;
     else
-        m->strVRDEAuthLibrary = "VRDPAuth";
+        m->strVRDEAuthLibrary = "VBoxAuth";
 
     return S_OK;
@@ -1074,5 +1074,5 @@
         m->strWebServiceAuthLibrary = aPath;
     else
-        m->strWebServiceAuthLibrary = "VRDPAuth";
+        m->strWebServiceAuthLibrary = "VBoxAuth";
 
     return S_OK;
Index: trunk/src/VBox/Main/idl/VirtualBox.xidl
===================================================================
--- trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 34562)
+++ trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 34563)
@@ -7512,5 +7512,5 @@
         system's default library path.
 
-        The default value of this property is <tt>"VRDPAuth"</tt>. There is a library
+        The default value of this property is <tt>"VBoxAuth"</tt>. There is a library
         of that name in one of the default VirtualBox library directories.
 
@@ -7539,5 +7539,5 @@
         no matter what user name and password are supplied.
 
-        The initial value of this property is <tt>"VRDPAuth"</tt>,
+        The initial value of this property is <tt>"VBoxAuth"</tt>,
         meaning that the webservice will use the same authentication
         library that is used by default for VRDE (again, see
Index: trunk/src/VBox/Main/include/ConsoleVRDPServer.h
===================================================================
--- trunk/src/VBox/Main/include/ConsoleVRDPServer.h	(revision 34562)
+++ trunk/src/VBox/Main/include/ConsoleVRDPServer.h	(revision 34563)
@@ -24,5 +24,5 @@
 #include <hgcm/HGCM.h>
 
-#include <VBox/VRDPAuth.h>
+#include <VBox/VBoxAuth.h>
 
 #include <VBox/HostServices/VBoxClipboardExt.h>
Index: trunk/src/VBox/Main/include/VRDEServerImpl.h
===================================================================
--- trunk/src/VBox/Main/include/VRDEServerImpl.h	(revision 34562)
+++ trunk/src/VBox/Main/include/VRDEServerImpl.h	(revision 34563)
@@ -23,5 +23,5 @@
 #include "VirtualBoxBase.h"
 
-#include <VBox/VRDPAuth.h>
+#include <VBox/VBoxAuth.h>
 #include <VBox/settings.h>
 
Index: trunk/src/VBox/Main/webservice/vboxweb.cpp
===================================================================
--- trunk/src/VBox/Main/webservice/vboxweb.cpp	(revision 34562)
+++ trunk/src/VBox/Main/webservice/vboxweb.cpp	(revision 34563)
@@ -25,5 +25,5 @@
 #include <VBox/com/errorprint.h>
 #include <VBox/com/EventQueue.h>
-#include <VBox/VRDPAuth.h>
+#include <VBox/VBoxAuth.h>
 #include <VBox/version.h>
 
Index: trunk/src/VBox/Main/webservice/websrv-cpp.xsl
===================================================================
--- trunk/src/VBox/Main/webservice/websrv-cpp.xsl	(revision 34562)
+++ trunk/src/VBox/Main/webservice/websrv-cpp.xsl	(revision 34563)
@@ -67,5 +67,5 @@
 #include <VBox/com/errorprint.h>
 #include <VBox/com/EventQueue.h>
-#include <VBox/VRDPAuth.h>
+#include <VBox/VBoxAuth.h>
 #include <VBox/version.h>
 