Index: trunk/src/VBox/Installer/linux/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/linux/Makefile.kmk	(revision 34582)
+++ trunk/src/VBox/Installer/linux/Makefile.kmk	(revision 34584)
@@ -200,13 +200,15 @@
 # VRDP
 ifdef VBOX_WITH_VRDP
- VBOX_LNX_STRIP_BIN += \
-	VBoxVRDP.so
+ ifndef VBOX_WITH_EXTPACK_PUEL
+  VBOX_LNX_STRIP_BIN += \
+  	VBoxVRDP.so
+ endif
  ifdef VBOX_WITH_VRDP_RDESKTOP
   VBOX_LNX_NO_STRIP += \
-	rdesktop-vrdp.tar.gz
+  	rdesktop-vrdp.tar.gz
   VBOX_LNX_NO_STRIP += \
-	rdesktop-vrdp-keymaps
+  	rdesktop-vrdp-keymaps
   VBOX_LNX_STRIP_BIN += \
-	rdesktop-vrdp
+  	rdesktop-vrdp
  endif
 endif
@@ -214,21 +216,21 @@
 # Python XPCOM glue
 ifdef VBOX_WITH_PYTHON
-  VBOX_LNX_NO_STRIP += \
-	$(foreach f,$(notdir $(wildcard $(PATH_BIN)/sdk/bindings/xpcom/python/xpcom/*.py)),sdk/bindings/xpcom/python/xpcom/$(f)) \
-	sdk/bindings/xpcom/python/xpcom/client/__init__.py \
-        sdk/bindings/xpcom/python/xpcom/server/__init__.py \
-	sdk/bindings/xpcom/python/xpcom/server/enumerator.py \
-	sdk/bindings/xpcom/python/xpcom/server/factory.py \
-	sdk/bindings/xpcom/python/xpcom/server/loader.py \
-	sdk/bindings/xpcom/python/xpcom/server/module.py \
-	sdk/bindings/xpcom/python/xpcom/server/policy.py \
-	sdk/installer/vboxapisetup.py \
-	sdk/installer/vboxapi/__init__.py \
-	sdk/installer/vboxapi/VirtualBox_constants.py
+ VBOX_LNX_NO_STRIP += \
+ 	$(foreach f,$(notdir $(wildcard $(PATH_BIN)/sdk/bindings/xpcom/python/xpcom/*.py)),sdk/bindings/xpcom/python/xpcom/$(f)) \
+ 	sdk/bindings/xpcom/python/xpcom/client/__init__.py \
+ 	sdk/bindings/xpcom/python/xpcom/server/__init__.py \
+ 	sdk/bindings/xpcom/python/xpcom/server/enumerator.py \
+ 	sdk/bindings/xpcom/python/xpcom/server/factory.py \
+ 	sdk/bindings/xpcom/python/xpcom/server/loader.py \
+ 	sdk/bindings/xpcom/python/xpcom/server/module.py \
+ 	sdk/bindings/xpcom/python/xpcom/server/policy.py \
+ 	sdk/installer/vboxapisetup.py \
+ 	sdk/installer/vboxapi/__init__.py \
+ 	sdk/installer/vboxapi/VirtualBox_constants.py
 endif
 
 # Java XPCOM bridge
 ifdef VBOX_WITH_JXPCOM
-  VBOX_LNX_NO_STRIP += \
+ VBOX_LNX_NO_STRIP += \
 	sdk/bindings/xpcom/java/vboxjxpcom.jar
 endif
@@ -244,6 +246,6 @@
 ifdef VBOX_WITH_BFE
  VBOX_LNX_STRIP_BIN += \
-	VBoxBFE \
-	$(if $(VBOX_WITH_HARDENING),VBoxBFE.so)
+ 	VBoxBFE \
+ 	$(if $(VBOX_WITH_HARDENING),VBoxBFE.so)
 endif
 
@@ -251,13 +253,13 @@
 ifdef VBOX_WITH_WEBSERVICES
  VBOX_LNX_STRIP_BIN += \
-	vboxwebsrv \
-	webtest
+ 	vboxwebsrv \
+ 	webtest
 endif
 
 # EFI firmware
 ifdef VBOX_WITH_EFIFW_PACKING
-  VBOX_LNX_NO_STRIP += \
-	VBoxEFI32.fd \
-	VBoxEFI64.fd
+ VBOX_LNX_NO_STRIP += \
+ 	VBoxEFI32.fd \
+ 	VBoxEFI64.fd
 endif
 
Index: trunk/src/VBox/Installer/solaris/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/solaris/Makefile.kmk	(revision 34582)
+++ trunk/src/VBox/Installer/solaris/Makefile.kmk	(revision 34584)
@@ -341,12 +341,14 @@
 # VRDP
 ifdef VBOX_WITH_VRDP
- SOLARIS_STRIP_BINS += \
-	VBoxVRDP.so
+ ifndef VBOX_WITH_EXTPACK_PUEL
+  SOLARIS_STRIP_BINS += \
+  	VBoxVRDP.so
+ endif
  SOLARIS_COMMON += \
-	rdesktop-vrdp.tar.gz
+ 	rdesktop-vrdp.tar.gz
  ifdef VBOX_WITH_VRDP_RDESKTOP
   SOLARIS_COMMON += $(addprefix rdesktop-vrdp-keymaps/,$(notdir $(wildcard $(SOLARIS_OUT_BIN)/rdesktop-vrdp-keymaps/*)))
   SOLARIS_STRIP_EXES += \
-	rdesktop-vrdp
+  	rdesktop-vrdp
  endif
 endif
@@ -369,5 +371,5 @@
 # EFI firmware
 ifdef VBOX_WITH_EFIFW_PACKING
-  SOLARIS_COMMON += \
+ SOLARIS_COMMON += \
 	VBoxEFI32.fd \
 	VBoxEFI64.fd
Index: trunk/src/VBox/Installer/win/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/win/Makefile.kmk	(revision 34582)
+++ trunk/src/VBox/Installer/win/Makefile.kmk	(revision 34584)
@@ -372,5 +372,5 @@
 		-E 'VBOX_WITH_QTGUI=$(if $(VBOX_WITH_QTGUI),yes,no)' \
 		-E 'VBOX_WITH_VIDEOHWACCEL=$(if $(VBOX_WITH_VIDEOHWACCEL),yes,no)' \
-		-E 'VBOX_WITH_VRDP=$(if $(VBOX_WITH_VRDP),yes,no)' \
+		-E 'VBOX_WITH_VRDP=$(if-expr defined(VBOX_WITH_VRDP) && !defined(VBOX_WITH_EXTPACK_PUEL),yes,no)' \
 		-E 'VBOX_WITH_WEBSERVICES=$(if $(VBOX_WITH_WEBSERVICES),yes,no)' \
 		-E 'VBOX_WITH_SECURELABEL=$(if $(VBOX_WITH_SECURELABEL),yes,no)' \