Index: trunk/src/VBox/Installer/win/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/win/Makefile.kmk	(revision 34584)
+++ trunk/src/VBox/Installer/win/Makefile.kmk	(revision 34630)
@@ -107,5 +107,5 @@
 		$(VBOX_WIN_INST_OUT_DIR)/$(PACKAGE_NAME_LANG)_$(lang).msi) \
 	$(VBOX_WIN_INST_OUT_DIR)/Files_Doc.wxi \
-	$(VBOX_WIN_INST_OUT_DIR)/Files_License.wxi
+	$(if $(VBOX_WITH_LICENSE_DISPLAY), $(VBOX_WIN_INST_OUT_DIR)/Files_License.wxi)
 
 ifdef VBOX_WITH_COMBINED_PACKAGE
@@ -231,4 +231,5 @@
 	$(APPEND) $@ '</Include>'
 
+ifdef VBOX_WITH_LICENSE_DISPLAY
 $(VBOX_WIN_INST_OUT_DIR)/Files_License.wxi: $(MAKEFILE_CURRENT) | $$(dir $$@)
 	$(call MSG_GENERATE,,$@,$<)
@@ -243,5 +244,5 @@
 	             '	</File>')
 	$(APPEND) $@ '</Include>'
-
+endif
 
 #
@@ -376,4 +377,5 @@
 		-E 'VBOX_WITH_SECURELABEL=$(if $(VBOX_WITH_SECURELABEL),yes,no)' \
 		-E 'VBOX_WITH_SERIALNUMBER_INSTALL=$(if $(VBOX_WITH_SERIALNUMBER_INSTALL),yes,no)' \
+		-E 'VBOX_WITH_LICENSE_DISPLAY=$(if $(VBOX_WITH_LICENSE_DISPLAY),yes,no)' \
 		-E 'VBOX_WINDOWS_ICON_FILE=$(subst /,\\,$(VBOX_WINDOWS_ICON_FILE))' \
 		-E 'BUILD_TYPE=$(KBUILD_TYPE)' \
@@ -471,5 +473,5 @@
 		$(VBOX_WIN_INST_OUT_DIR)/Files_Main.wxi \
 		$(VBOX_WIN_INST_OUT_DIR)/Files_Doc.wxi \
-		$(VBOX_WIN_INST_OUT_DIR)/Files_License.wxi \
+		$(if $(VBOX_WITH_LICENSE_DISPLAY), $(VBOX_WIN_INST_OUT_DIR)/Files_License.wxi) \
 		$(foreach lang,$(VBOX_INSTALLER_LANGUAGES), $(VBOX_WIN_INST_OUT_DIR)/$(PACKAGE_NAME_LANG)_$(lang).msi) \
 		$(foreach lang,$(VBOX_INSTALLER_ADD_LANGUAGES),	$(VBOX_WIN_INST_OUT_DIR)/Languages/$(lang).mst) \
Index: trunk/src/VBox/Installer/win/UserInterface.wxi
===================================================================
--- trunk/src/VBox/Installer/win/UserInterface.wxi	(revision 34584)
+++ trunk/src/VBox/Installer/win/UserInterface.wxi	(revision 34630)
@@ -57,7 +57,18 @@
             </Control>
 
-            <!-- Next dialog is the license agreement -->
             <Control Id="Next" Type="PushButton" X="236" Y="243" Width="56" Height="17" Default="yes" Text="$(loc.ButtonText_Next)">
-                 <Publish Event="NewDialog" Value="LicenseAgreementDlg">1</Publish>
+        <?if $(env.VBOX_WITH_LICENSE_DISPLAY) = "yes" ?>
+                <!-- Next dialog is the license agreement -->
+                <Publish Event="NewDialog" Value="LicenseAgreementDlg">1</Publish>
+        <?else ?>
+                <!-- Decide which dialog to show next: The serial number dialog (if this is a branded build)
+                     or directly proceed to the customization dialog (Vbox not installed yet) -->
+                <?if $(env.VBOX_WITH_SERIALNUMBER_INSTALL) = "yes" ?>
+                    <Publish Event="NewDialog" Value="CheckSerialDlg">1</Publish>
+                <?else ?>
+                    <Publish Event="NewDialog" Value="CustomizeDlg"><![CDATA[(PREVIOUSVERSIONSINSTALLED OR NEWERVERSIONDETECTED)]]></Publish>
+                    <Publish Event="NewDialog" Value="CustomizeDlg"><![CDATA[(NOT PREVIOUSVERSIONSINSTALLED) AND (NOT NEWERVERSIONDETECTED)]]></Publish>
+                <?endif ?>
+        <?endif ?>
             </Control>
 
@@ -177,5 +188,9 @@
 
             <Control Id="Back" Type="PushButton" X="180" Y="243" Width="56" Height="17" Text="$(loc.ButtonText_Back)">
-                 <Publish Event="NewDialog" Value="LicenseAgreementDlg">1</Publish>
+        <?if $(env.VBOX_WITH_LICENSE_DISPLAY) = "yes" ?>
+                <Publish Event="NewDialog" Value="LicenseAgreementDlg">1</Publish>
+        <?else ?>
+                <Publish Event="NewDialog" Value="WelcomeDlg">1</Publish>
+        <?endif ?>
             </Control>
             <Control Id="Next" Type="PushButton" X="236" Y="243" Width="56" Height="17" Default="yes" Text="$(loc.ButtonText_Check)">
@@ -275,6 +290,10 @@
 
             <Control Id="Back" Type="PushButton" X="180" Y="243" Width="56" Height="17" Text="$(loc.ButtonText_Back)">
+        <?if $(env.VBOX_WITH_LICENSE_DISPLAY) = "yes" ?>
                 <Publish Event="NewDialog" Value="LicenseAgreementDlg"><![CDATA[(NOT CHECKSERIAL) AND (InstallMode = "$(loc.InstallModeCustom)")]]></Publish>
                 <Publish Event="NewDialog" Value="CheckSerialDlg"><![CDATA[CHECKSERIAL]]></Publish>
+        <?else ?>
+                <Publish Event="NewDialog" Value="WelcomeDlg">1</Publish>
+        <?endif ?>
             </Control>
             <Control Id="Next" Type="PushButton" X="236" Y="243" Width="56" Height="17" Default="yes" Text="$(loc.ButtonText_Next)">
Index: trunk/src/VBox/Installer/win/VirtualBox.wxs
===================================================================
--- trunk/src/VBox/Installer/win/VirtualBox.wxs	(revision 34584)
+++ trunk/src/VBox/Installer/win/VirtualBox.wxs	(revision 34630)
@@ -400,6 +400,8 @@
                         <?include $(env.PATH_TARGET)\Files_Main.wxi ?>
 <?endif ?>
+<?if $(env.VBOX_WITH_LICENSE_DISPLAY) = "yes" ?>
                         <!-- Include all license files (file is generated by makefile). -->
                         <?include $(env.PATH_TARGET)\Files_License.wxi ?>
+<?endif ?>
 
 <?if $(env.VBOX_WITH_DEBUGGER_GUI) = "yes" ?>