Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxProblemReporter.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxProblemReporter.cpp	(revision 34805)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxProblemReporter.cpp	(revision 34806)
@@ -2142,9 +2142,29 @@
 }
 
-bool VBoxProblemReporter::confirmRemovingPackage(const QString &strPackName, QWidget *pParent /* = 0 */)
+bool VBoxProblemReporter::confirmInstallingPackage(const QString &strPackName, const QString &strPackVersion,
+                                                   const QString &strPackDescription, QWidget *pParent /* = 0 */)
 {
     return messageOkCancel (pParent ? pParent : mainWindowShown(),
                             Question,
-                            tr("You are about to remove the Extension Pack <b>%1</b>. Are you sure you want to do that?").arg(strPackName),
+                            tr("<p>You are about to install a VirtualBox extension pack. "
+                               "Extension packs complement the functionality of VirtualBox and can contain system level software "
+                               "that could be potentially harmful to your system. Please review the description below and only proceed "
+                               "if you have obtained the extension pack from a trusted source.</p>"
+                               "<p><table cellpadding=0 cellspacing=0>"
+                               "<tr><td><b>Name:&nbsp;&nbsp;</b></td><td>%1</td></tr>"
+                               "<tr><td><b>Version:&nbsp;&nbsp;</b></td><td>%2</td></tr>"
+                               "<tr><td><b>Description:&nbsp;&nbsp;</b></td><td>%3</td></tr>"
+                               "</table></p>")
+                               .arg(strPackName).arg(strPackVersion).arg(strPackDescription),
+                            0,
+                            tr("&Install"));
+}
+
+bool VBoxProblemReporter::confirmRemovingPackage(const QString &strPackName, QWidget *pParent /* = 0 */)
+{
+    return messageOkCancel (pParent ? pParent : mainWindowShown(),
+                            Question,
+                            tr("<p>You are about to remove the VirtualBox extension pack <b>%1</b>.</p>"
+                               "<p>Are you sure you want to do that?</p>").arg(strPackName),
                             0,
                             tr("&Remove"));
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxProblemReporter.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxProblemReporter.h	(revision 34805)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxProblemReporter.h	(revision 34806)
@@ -342,4 +342,5 @@
     void cannotInstallExtPack(const QString &strFilename, const CExtPackFile &extPackFile, QWidget *pParent = 0);
     void cannotUninstallExtPack(const QString &strPackName, const CExtPackManager &extPackManager, QWidget *pParent = 0);
+    bool confirmInstallingPackage(const QString &strPackName, const QString &strPackVersion, const QString &strPackDescription, QWidget *pParent = 0);
     bool confirmRemovingPackage(const QString &strPackName, QWidget *pParent = 0);
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsExtension.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsExtension.cpp	(revision 34805)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsExtension.cpp	(revision 34806)
@@ -50,5 +50,5 @@
 
         /* Version: */
-        setText(2, m_data.m_strVersion);
+        setText(2, QString("%1.%2").arg(m_data.m_strVersion).arg(m_data.m_strRevision));
 
         /* Tool-tip: */
@@ -120,7 +120,5 @@
     bool fInstalled = false;
 
-    /*
-     * Open the extpack tarball via IExtPackManager.
-     */
+    /* Open the extpack tarball via IExtPackManager: */
     CExtPackManager manager = vboxGlobal().virtualBox().GetExtensionPackManager();
     CExtPackFile extPackFile = manager.OpenExtPackFile(strFilePath);
@@ -131,17 +129,13 @@
         if (extPackFile.GetUsable())
         {
-            bool fAck = true;
-            /** @todo display big fat warning message. */
+            bool fAck = vboxProblem().confirmInstallingPackage(extPackFile.GetName(),
+                                                               QString("%1.%2").arg(extPackFile.GetVersion()).arg(extPackFile.GetRevision()),
+                                                               extPackFile.GetDescription());
 
             if (fAck)
             {
-                /** @todo display licenses.  */
-            }
-
-            /*
-             * Install it if everything was ACKed by the user.
-             */
-            if (fAck)
-            {
+                /* TODO: Display license! */
+
+                /* Install package: */
                 extPackFile.Install();
                 if (extPackFile.isOk())
@@ -278,8 +272,6 @@
         if (doInstallation(strFilePath, this, &strExtPackName))
         {
-            /*
-             * Insert the fresly installed extension pack, mark it as
-             * current in the tree and sort by name (col 1).
-             */
+            /* Insert the fresly installed extension pack, mark it as
+             * current in the tree and sort by name (col 1): */
             CExtPackManager manager = vboxGlobal().virtualBox().GetExtensionPackManager();
             const CExtPack &package = manager.Find(strExtPackName);